
def load_function_data(filename):
	f = open(filename)
	go ={}

	for row in f:
		data = row.split()
		gene = data[0]
		domain = data[3]
		goterm = data[4]
		if not domain in go:
			go[domain] = {}
		if not goterm in go[domain]:
			go[domain][goterm] = [gene]
		else:
			go[domain][goterm].append(gene)

	f.close()
	return go

def load_expression_data(filename):
	f = open(filename)
	gene2expr = {}
	
	numexpr = len(f.readline().split())-3
	f.readline()

	for row in f.readlines():
		data = row.split()
		gene = data[0]
		expr = [float(exp) for exp in data[3:]]
		gene2expr[gene] = expr

	f.close()
	return numexpr,gene2expr

def compute_average_profile(genes4term, gene2expr, numexpr):
	avg = [0] * numexpr

	for gene in genes4term:
		expr = gene2expr[gene]
		for i in range(numexpr):
			avg[i] += expr[i]

	for i in range(numexpr):
		avg[i] /= len(genes4term)

	return avg

def print_frequent_term_profiles(go_domain, thres, gene2expr, numexpr):

	for term,genes in go_domain.items():
		if len(genes) < thres:
			continue
		avg_profile = compute_average_profile(genes, gene2expr, numexpr)
		print(term + "\t" + "\t".join(["%.3f" %avg for avg in avg_profile]))


gofile = input("Inserire nome file GO terms: ")
expfile = input("Inserire nome file espressioni: ")
domain = input("Inserire dominio (C/F/P): ")
thres = int(input("Inserire numero minimo geni: "))

go = load_function_data(gofile)
numexpr,gene2expr = load_expression_data(expfile)

print_frequent_term_profiles(go[domain], thres, gene2expr, numexpr)


