
def load_cath_names(filename):
	f = open(filename)
	names = {}
	for row in f:
		data = row.split()
		if len(data) == 1:
			names[data[0]] = ""
		else:
			names[data[0]] = " ".join(data[1:])
	f.close()
	return names

def load_cath_domains(filename):
	f = open(filename)
	domains = []
	for row in f:
		data = row.split()
		domains.append((data[0],data[2]))
	f.close()
	return domains

def domains2dict(domains, level):
	dict = {}
	for (domain,code) in domains:
		prefix=".".join(code.split('.')[:level])
		if not prefix in dict:
			dict[prefix] = [domain]
		else:
			dict[prefix].append(domain)
	return dict

def print_stats(code2domains, names, thres):
	code2num = [(len(domains),code) for (code, domains) in code2domains.items()]
	code2num.sort()
	code2num.reverse()
	for (num,code) in code2num:
		if num < thres:
			break
		print("%s (%s)\t%d" %(code,names[code],num))

namesfile = input("CATH names file: ")
domainsfile = input("CATH domains file: ")
level = int(input("CATH level (1-4): "))
thres = int(input("Frequency threshold: "))

names = load_cath_names(namesfile)
domains = load_cath_domains(domainsfile)
code2domains = domains2dict(domains, level)

print_stats(code2domains, names, thres)


