
def load_fasta(filename):

	f = open(filename)
	prots = {}
	name = ""
	seq = ""
	for row in f:
		if row[0] == '>':
			if name:
				prots[name] = seq
			name = row[1:].strip()
			seq = ""
		else:
			seq += row.strip()
	if name:
		prots[name] = seq
	f.close()
	return prots

def sequences2stats(prots, k):
	for name,seq in prots.items():
		print(name)
		print("kmers",sequence2kmers(prots[name], k))
		print("repetitions", sequence2repetitions(prots[name]))

def sequence2kmers(seq, k):
	kmers = {}

	for i in range(len(seq)-k):
		kmer = seq[i:i+k]
		if kmer in kmers:
			kmers[kmer] += 1
		else:
			kmers[kmer] = 1

	return kmers

def sequence2repetitions(seq):
	i = 0
	repetitions = {}
	repetition = seq[0]

	while i < len(seq)-1:
		i = i+1
		if seq[i] == repetition[-1]:
				repetition += seq[i]
		else:
			if len(repetition) > 1:
				if repetition in repetitions:
					repetitions[repetition] += 1
				else:	 	
					repetitions[repetition] = 1
			repetition = seq[i]	
	if len(repetition) > 1:
		if repetition in repetitions:
			repetitions[repetition] += 1
		else:	 	
			repetitions[repetition] = 1	
	return repetitions

fastafile = input("Inserire nome file fasta: ")
k = int(input("Inserire lunghezza kmers: "))
prots = load_fasta(fastafile)
sequences2stats(prots, k)


